// strutils.pp
{$mode objfpc}
program showmethewild;
uses strutils;

//{$define d}  // for debug dddddddd
type Arr_string=array of string;
type Arr_integer=array of integer;

//-------------------------------------------------------------------

procedure extract2(sub:string; var t,c:string);  // T=head   C=tail
begin     // you must run it after FIX_SUB
t:='';             // aa??*bb --> aa/??/*/bb
c:='';
if sub='' then Exit;
case sub[1] of
     '*' : begin
           t:='*';
           c:=copy(sub,2,length(sub));
           end;
     '?' : begin
           while (sub<>'') and (sub[1]='?') do
                 begin
                 t:=t+'?';
                 sub:=copy(sub,2,length(sub));
                 end;
           c:=sub;
           end;
     else    // a normal string
           begin
           while (sub<>'') and not (sub[1] in ['?','*']) do
                 begin
                 t:=t+sub[1];
                 sub:=copy(sub,2,length(sub));
                 end;
           c:=sub;
           end;
     end; // case
end;

//-------------------------------------------------------------------

procedure extract3(sub:string; var t,c:string);  // T=head   C=tail
begin     // you must run it after FIX_SUB
t:='';            // aa??*bb --> aa/??*/bb
c:='';
if sub='' then Exit;
case sub[1] of
     '?','*' :
           begin
           while (sub<>'') and ( (sub[1]='?') or (sub[1]='*') ) do
                 begin
                 t:=t+sub[1];
                 sub:=copy(sub,2,length(sub));
                 end;
           c:=sub;
           end;
     else    // a normal string
           begin
           while (sub<>'') and not (sub[1] in ['?','*']) do
                 begin
                 t:=t+sub[1];
                 sub:=copy(sub,2,length(sub));
                 end;
           c:=sub;
           end;
     end; // case
end;

//-------------------------------------------------------------------

function fix_sub(const sub:string):string;
var i:integer;       // aaa?*?**p??*???p* --> aaa??*p?????*p
    s:string;
    was_asterisk:boolean;
begin
was_asterisk:=false;
s:='';
for i:=1 to length(sub) do
    case sub[i] of
         '*' : was_asterisk:=true;
         '?' : s:=s+sub[i];
         else
          begin
          if was_asterisk then
             begin
             s:=s+'*';
             was_asterisk:=false;
             end;
          s:=s+sub[i];
          end;
         end;
while (s<>'')and(s[length(s)]='*') do s:=copy(s,1,length(s)-1);
exit(s);
end;

//-------------------------------------------------------------------

function get_invalid_char(const str:string):char;
begin
if (length(str)>1) and (str[1]<#255) then get_invalid_char:=char(ord(str[1])+1)
                                     else get_invalid_char:=#0;

end;

//-------------------------------------------------------------------

function get_ask_count(const sub:string):integer;
var i,num_primi_p_int:integer;    // you must run it after FIX_SUB
begin
num_primi_p_int:=0;
for i:=1 to length(sub) do
    if sub[i]='?' then inc(num_primi_p_int)
                  else break;
get_ask_count:=num_primi_p_int;
end;

//-------------------------------------------------------------------

procedure get_first_word(sub:string; var word:string; var position:integer);
var t1,t2,t3,c,original_sub:string;   // ??*aa*a??  --> aa , pos=4
begin
original_sub:=sub;
extract2(sub,t1,c);  // T=head   C=tail
sub:=c;
extract2(sub,t2,c);  // T=head   C=tail
sub:=c;
extract2(sub,t3,c);  // T=head   C=tail
word:='';
if (t1<>'')and not (t1[1] in ['?','*']) then word:=t1 else
if (t2<>'')and not (t2[1] in ['?','*']) then word:=t2 else
if (t3<>'')and not (t3[1] in ['?','*']) then word:=t3;
position:=pos(word,original_sub);
end;

//-------------------------------------------------------------------

procedure pos2(sub,str:string; var solution: Arr_integer);
var bad:char;
    position:integer;
begin
setlength(solution,0);
bad:=get_invalid_char(sub);
while true do
      begin
      position:=pos(sub,str);
      if position>0 then
                     begin
                     setlength(solution,length(solution)+1);
                     solution[length(solution)-1]:=position;
                     str[position]:=bad;
                     end
                    else break;
      end;
end;

//-------------------------------------------------------------------

procedure generate_str(const str_in:string; const solution:arr_integer; const bad:char; var new_str_in:arr_string);
var i:integer;
begin
for i:=0 to length(solution)-1 do
    begin
    setlength(new_str_in,length(new_str_in)+1);
    new_str_in[length(new_str_in)-1]:=str_in;
    new_str_in[length(new_str_in)-1][solution[i]]:=bad;
    end;
end;

//-------------------------------------------------------------------

procedure get_all_word(sub:string; var words:Arr_String);
var t,c:string;
begin
setlength(words,0);
while sub<>'' do
      begin
      extract2(sub,t,c);
      sub:=c;
      if (t<>'') and not (t[1] in ['?','*']) then  // is a word: insert it
         begin
         setlength(words,length(words)+1);
         words[length(words)-1]:=t;
         end;
      end;
end;

//-------------------------------------------------------------------

procedure generate(var all_str:arr_string; const length_words:integer; const solution:arr_integer);
var new_all_str:arr_string;
    index_,fix_pos,i,j,k,last_used_position:integer;
begin
setlength(new_all_str,length(all_str)*length(solution));
index_:=0;
for i:=0 to length(all_str)-1 do  // multiplication of all_str
    begin
    fix_pos:=0;
    for k:=0 to length(solution)-1 do
        begin
        new_all_str[index_]:=all_str[i];
        last_used_position:=0;
//        for j:=1 to length(new_all_str[index_]) do        //ddddd
//            if new_all_str[index_][j]='0' then last_used_position:=j; //ddddd
        for j:=length(new_all_str[index_]) downto 1 do        //ddddd
            if new_all_str[index_][j]='0' then
               begin
               last_used_position:=j; //ddddd
               break;
               end;

        if (last_used_position<solution[fix_pos])or(last_used_position=0) then // skip position before have sense
           for j:=0 to length_words-1 do new_all_str[index_][solution[fix_pos]+j]:='0';
        inc(index_);
        inc(fix_pos);
        end;
    end;
setlength(all_str,0);
all_str:=new_all_str;
end;

//-------------------------------------------------------------------

procedure split_sub(sub:string; var sub_words:Arr_string);
var t,c:string;      // aa??*bb --> [aa,??*,bb]
begin
setlength(sub_words,0);
while sub<>'' do
      begin
      extract3(sub,t,c);
      sub:=c;
      setlength(sub_words,length(sub_words)+1);
      sub_words[length(sub_words)-1]:=t;
      end;
end;

//-------------------------------------------------------------------

procedure get_n_sub(n_word:integer; const sub_word:Arr_string; var sub_n,sub_nn:string);  // n_word start from 1, as 0
begin
n_word:=n_word*2-1;
sub_n:='';
sub_nn:='';
dec(n_word);
if (n_word<0)or(length(sub_word)=0)or(n_word>=length(sub_word)) then Exit;
if sub_word[n_word][1] in ['?','*'] then inc(n_word);
if n_word>=length(sub_word) then Exit;
sub_n:=sub_word[n_word];
if n_word+1>=length(sub_word) then Exit;
sub_nn:=sub_word[n_word+1];
end;

//-------------------------------------------------------------------

procedure get_n_word(n_word:integer; words:string; var sub_n,sub_nn:string);
var i:integer;    // n_word start from 1 (not from 0)
begin
sub_n:='';
sub_nn:='';
if n_word<1 then Exit;
for i:=1 to n_word-1 do
    begin
    while (length(words)>0) and (words[1]='.') do words:=copy(words,2,length(words));
    while (length(words)>0) and (words[1]='0') do words:=copy(words,2,length(words));
    end;
while (length(words)>0) and (words[1]='.') do words:=copy(words,2,length(words));
while (length(words)>0) and (words[1]='0') do
      begin
      sub_n:=sub_n+'0';
      words:=copy(words,2,length(words));
      end;
while (length(words)>0) and (words[1]='.') do
      begin
      sub_nn:=sub_nn+'.';
      words:=copy(words,2,length(words));
      end;
end;

//-------------------------------------------------------------------

procedure check_asterisk(var multi_solution:integer; sub_word:string);
begin
if pos('*',sub_word)>0 then multi_solution:=1;
end;

//-------------------------------------------------------------------

function  f_get_n_word(n_word:integer; const str:string):string;
var str_n,str_nn:string;
begin
get_n_word(n_word,str,str_n,str_nn);
exit(str_n);
end;

//-------------------------------------------------------------------

function FindPart2(sub, Str: string): Integer;
var words,all_str,sub_word: Arr_string;
    solution,multi_solution: Arr_integer;
    get_ask_count_,value,i,n_word:integer;
    sub_n,sub_nn,str_n,str_nn:string;
    all_0:boolean;
// the author of this function and sub functions is Salvatore Licciardi
begin
if (sub='')or(Str='') then Exit(0);
sub:=fix_sub(sub);
get_all_word(sub,words);
get_ask_count_:=get_ask_count(sub);
if length(words)=0 then       // condition ??*  or ????
   if get_ask_count_>length(str) then Exit(0)
                                 else exit(1);
setlength(all_str,1);
all_str[0]:='';
while length(all_str[0])<length(str) do all_str[0]:='.'+all_str[0]; // first string generated

for i:=0 to length(words)-1 do
    begin
    pos2(words[i],str,solution);
    generate(all_str,length(words[i]),solution);
    end;

{$ifdef d}for i:=0 to length(words)-1 do write(words[i],'|'); writeln;{$endif} //test OK
{$ifdef d}for i:=0 to length(all_str)-1 do writeln(all_str[i],'|');writeln;  {$endif}//test OK
split_sub(sub,sub_word);

{$ifdef d}
writeln('-------');
for i:=0 to length(sub_word)-1 do write(sub_word[i],'|'); writeln; {$endif} //test OK

setlength(multi_solution,length(all_str));
for i:=0 to length(all_str)-1 do
    begin
    n_word:=0;
    multi_solution[i]:=pos('0',all_str[i]);
  {$ifdef d}    writeln(multi_solution[i]);  {$endif}// TEST OK
    while true do
          begin
          get_n_sub(n_word+1,sub_word,sub_n,sub_nn);
  {$ifdef d}        writeln('sub_n,sub_nn ',sub_n,'   ',sub_nn); {$endif} //ddddd
          if sub_n='' then break;
          get_n_word(n_word+1,all_str[i],str_n,str_nn);
  {$ifdef d}        writeln('str_n,str_nn ',str_n,'   ',str_nn); {$endif}//ddddd
          if {(sub_n<>'') and} ( length(sub_n)=length(str_n) )  and
          ( (sub_nn='') or (length(sub_nn)=length(str_nn)) or
            ( (length(sub_nn)<length(str_nn))and(f_get_n_word(n_word+2,all_str[i])=''{n_word+1+1<length(sub_word)} {is last word ddd})   ) or
          ( (length(sub_nn)<length(str_nn))and(pos('*',sub_nn)>0) )  )
             then
              begin // there is a solution ?
(* //              writeln('OK   ',i+1,'   ',multi_solution[i]); // pos:=000 ???? dddddd  else rimane 0
              if get_ask_count_>multi_solution[i] then multi_solution[i]:=0
                                                  else multi_solution[i]:=multi_solution[i]-get_ask_count_;
              // cercare il primo *, se e' < ... soluz=1 dddddd
              check_asterisk(multi_solution[i],sub_word[0]); //ddd
{$ifdef d}              writeln('OK   ',i+1,'   ',multi_solution[i]); {$endif} // pos:=000 ???? dddddd  else rimane 0
  //            found_solution:=true;
//              multi_solution[i]:=0;  //dddd  *)
              end
             else
              begin
              multi_solution[i]:=0;
              break;
              end;
          inc(n_word);
          end;
    end;
value:=length(str);
{$ifdef d}              writeln('value ',value); {$endif} // pos:=000 ???? dddddd  else rimane 0
all_0:=true;
for i:=0 to length(multi_solution)-1 do // search the least that isn't 0
    begin
{$ifdef d}              writeln('OK   ',i+1,'   ',multi_solution[i]); {$endif} // pos:=000 ???? dddddd  else rimane 0
    if get_ask_count_>multi_solution[i] then multi_solution[i]:=0
                                        else multi_solution[i]:=multi_solution[i]-get_ask_count_;
    check_asterisk(multi_solution[i],sub_word[0]);
    if (multi_solution[i]>0) and (multi_solution[i]<value) then
                                                           begin
                                                           value:=multi_solution[i];
                                                           all_0:=false;
                                                           end;
    end;
if all_0 then value:=0;
Exit(value);
end;


//-------------------------------------------------------------------

function IsWild2(InputStr: String;  Wilds: String;  IgnoreCase: Boolean ):Boolean;
begin
if IgnoreCase then exit(FindPart2(upcase(Wilds),upcase(InputStr))>0)
              else exit(FindPart2(Wilds,InputStr)>0);
end;

begin
writeln('------------------');
writeln(FindPart2('??:??:??','     01:30:00'));           // 6
writeln(FindPart2('de?g','abcdefghdefgdefgg'));           // 4
writeln(FindPart2('de*','abcdefgh'));                     // 4
writeln(FindPart2('de???????op','abcdefghilmnopqrst'));   // 4
writeln(FindPart2('de??op','abcdefghilmnopqrst'));        // 0
writeln(FindPart2('de????????op','abcdefghilmnopqrst'));  // 0
writeln(FindPart2('de??**op','abcdefghilmnopqrst'));      // 4
writeln(FindPart2('de??**??op','abcdefghilmnopqrst'));    // 4
writeln(FindPart2('de??**op','abcdefghilmnopqrst'));      // 4
writeln(FindPart2('de??**o?q','abcdefghilmnopqrst'));     // 4
writeln(FindPart2('q','abcdefghilmnopqrst'));      // 15
writeln(FindPart2('','abcdefghilmnopqrst'));       // 0 come writeln(pos('','abcdefghilmnopqrst'));      // 0
writeln(FindPart2('*','abcdefghilmnopqrst'));      // 1
writeln(FindPart2('*?','abcdefghilmnopqrst'));     // 1
writeln(FindPart2('*?b','abcdefghilmnopqrst'));    // 1
writeln(FindPart2('?b','abcdefghilmnopqrst'));     // 1
writeln(FindPart2('b','abcdefghilmnopqrst'));      // 2
writeln(FindPart2('b********************************','abcdefghilmnopqrst')); // 2
writeln(FindPart2('b???????*?????????????????????????','abcdefghilmnopqrst'));// 0
writeln(FindPart2('??:??:??','12:00:30'));  // 1    OK
writeln(FindPart('??:??:??','12:00:30'));   // 1    OK
writeln(FindPart2('??:??:??','     01:30:00'));      // 6
writeln(FindPart2('*??*c','abcdefghilmnopqrst'));    // 1
writeln(FindPart2('?*?:??:??','     01:30:00'));     // 1 or 6
writeln(FindPart2('??:*?:??','     01:30:00'));      // 6
writeln(FindPart2('*?*?:??:??','     01:30:00'));    // 1
writeln(FindPart2('??:??:??','a12:13:14'));          // 2
writeln(FindPart2('ci?cio','cixxciociccio'));        // 8
writeln(FindPart2('?ci?cio','cixxciociccio'));       // 7
// writeln(FindPart ('?ci?cio','cixxciociccio'));       // 7
writeln(FindPart2('ci','cixxciociccio'));            // 1
writeln(FindPart2('?x?????????','cixxciociccioj'));  // 2
writeln(FindPart2('ci*o?o','ci*o?p?o?o'));  // 1 ok
end.

//----------------- DOCUMENTATION
 IsWild
 Check whether a string matches a wildcard
 search expression.

 Declaration
 Source position: strutils.pp line 158

 function IsWild(
   InputStr: String;
   Wilds: String;
   IgnoreCase: Boolean
 ):Boolean;



//-------------------------------- l'originale -- ORIGINAL VERISION
function FindPart(const HelpWilds, inputStr: string): Integer;
var
  i, J: Integer;
  Diff: Integer;
begin
  Result:=0;
  i:=Pos('?',HelpWilds);
  if (i=0) then
    Result:=Pos(HelpWilds, inputStr)
  else
    begin
    Diff:=Length(inputStr) - Length(HelpWilds);
    for i:=0 to Diff do
      begin
      for J:=1 to Length(HelpWilds) do
        if (inputStr[i + J] = HelpWilds[J]) or (HelpWilds[J] = '?') then
          begin
          if (J=Length(HelpWilds)) then
            begin
            Result:=i+1;
            Exit;
            end;
          end
        else
          Break;
      end;
    end;
end;


//----------------------------- DOCUMENTATION

27.3.37 FindPart
Synopsis: Search for a substring in a string, using wildcards.
Declaration: function FindPart(const HelpWilds: String;const InputStr: String)
: Integer

Visibility: default
Description: FindPart searches the string InputStr and returns the first
 string that matches the wildcards specification in HelpWilds . If no
 match is found, and empty string is returned. valid wildcards
are the "?" (question mark) and "*" (asterisk) characters.

Errors: None.



//-----------------------
function FindPart(const HelpWilds, inputStr: string): Integer;
var      // equivalente all'originale dddddd
  i,J,Diff: Integer;
begin
FindPart:=0;
i:=Pos('?',HelpWilds);
if (i=0) then
    FindPart:=Pos(HelpWilds, inputStr)
  else
    begin
    Diff:=Length(inputStr) - Length(HelpWilds);
    for i:=0 to Diff do
      for J:=1 to Length(HelpWilds) do
          if (inputStr[i + J] = HelpWilds[J]) or (HelpWilds[J] = '?') then
             if J=Length(HelpWilds) then Exit(i+1)
                                    else
             else Break;
    end;
end;




//-------------- TESTS
(*
get_n_sub(1{n_word},sub_word,sub_n,sub_nn);  // test OK

writeln(sub_n);
writeln(sub_nn);
get_n_sub(2{n_word},sub_word,sub_n,sub_nn);
writeln(sub_n);
writeln(sub_nn);
get_n_sub(3{n_word},sub_word,sub_n,sub_nn);
writeln(sub_n);
writeln(sub_nn);   //dddd *)


{writeln('....0..00...000....0000....00000.....');  // test OK
for i:=1 to 6 do   // test OK
    begin
    get_n_word(i,'....0..00...000....0000....00000.....',sub_n,sub_nn);  // test OK
    writeln(sub_n,'  ',sub_nn);
    end;  ///ddddd }


{var s:arr_integer; //dddddd sol_pos;
    i:integer;   }


(* writeln('------------------');
writeln(fix_sub('aaa?*?**p??*???p*'));

pos2('ab','ababab',s);
for i:=0 to length(s)-1 do writeln(s[i]); *)
