{$mode objfpc}
type Arr_string=array of string;
type Arr_integer=array of integer;

//-------------------------------------------------------------------

procedure extract3(sub:string; var t,c:string);  // T=head   C=tail
var jolly:boolean;
begin     // you must run it after FIX_SUB
t:='';            // aa??*bb --> aa/??*/bb
jolly:= (sub<>'')and(sub[1] in ['?','*']);
while (sub<>'') and ( ((sub[1] in ['?','*']) and jolly) or (not (sub[1] in ['?','*']) and not jolly) ) do
      begin
      t:=t+sub[1];
      sub:=copy(sub,2,length(sub));
      end;
c:=sub;
end;

//-------------------------------------------------------------------

function fix_sub(const sub:string):string;
var i:integer;       // aaa?*?**p??*???p* --> aaa??*p?????*p
    was_asterisk:boolean;
begin   // if sub=='*' , fix_sub return '', but after program do exit(1) : OK
was_asterisk:=false;
result:='';
for i:=1 to length(sub) do
    case sub[i] of
         '*' : was_asterisk:=true;
         '?' : result:=result+sub[i];
         else
          begin
          if was_asterisk then
             begin
             result:=result+'*';
             was_asterisk:=false;
             end;
          result:=result+sub[i];
          end;
         end;  // case
while (result<>'')and(result[length(result)]='*') do result:=copy(result,1,length(result)-1);
end;

//-------------------------------------------------------------------

function get_invalid_char(const str:string):char;
begin
if (length(str)>1) and (str[1]<#255) then get_invalid_char:=char(ord(str[1])+1)
                                     else get_invalid_char:=#0;
end;

//-------------------------------------------------------------------

function get_ask_count(const sub:string):integer;
begin     // you must run it after FIX_SUB
result:=0;
while (length(sub)>result)and(sub[result+1]='?') do inc(result);
end;

//-------------------------------------------------------------------

procedure pos2(sub,str:string; var solution: Arr_integer);
var bad:char;
    position:integer;
begin
setlength(solution,0);
bad:=get_invalid_char(sub);
repeat
 position:=pos(sub,str);
 if position=0 then break;
 setlength(solution,length(solution)+1);
 solution[length(solution)-1]:=position;
 str[position]:=bad;
until false;
end;

//-------------------------------------------------------------------

procedure generate_str(const str_in:string; const solution:arr_integer; const bad:char; var new_str_in:arr_string);
var i:integer;
begin
for i:=0 to length(solution)-1 do
    begin
    setlength(new_str_in,length(new_str_in)+1);
    new_str_in[length(new_str_in)-1]:=str_in;
    new_str_in[length(new_str_in)-1][solution[i]]:=bad;
    end;
end;

//-------------------------------------------------------------------

procedure get_all_word(sub:string; var words:Arr_String);
var t,c:string;     // T=head   C=tail
begin
setlength(words,0);
while sub<>'' do
      begin
      extract3(sub,t,c);
      sub:=c;
      if (t<>'') and not (t[1] in ['?','*']) then  // is a word: insert it
         begin
         setlength(words,length(words)+1);
         words[length(words)-1]:=t;
         end;
      end;
end;

//-------------------------------------------------------------------

procedure generate(var all_str:arr_string; const length_words:integer; const solution:arr_integer);
var new_all_str:arr_string;
    index_,fix_pos,i,j,k,last_used_position:integer;
begin
setlength(new_all_str,length(all_str)*length(solution));
index_:=0;
for i:=0 to length(all_str)-1 do  // multiplication of all_str
    begin
    fix_pos:=0;
    for k:=0 to length(solution)-1 do
        begin
        new_all_str[index_]:=all_str[i];
        last_used_position:=0;
        for j:=1 to length(new_all_str[index_]) do
            if new_all_str[index_][j]='0' then last_used_position:=j;
        if (last_used_position<solution[fix_pos])or(last_used_position=0) then // skip position before have sense
           for j:=0 to length_words-1 do new_all_str[index_][solution[fix_pos]+j]:='0';
        inc(index_);
        inc(fix_pos);
        end;
    end;
setlength(all_str,0);
all_str:=new_all_str;
end;

//-------------------------------------------------------------------

procedure split_sub(sub:string; var sub_words:Arr_string);
var t,c:string;      // aa??*bb --> [aa,??*,bb]
begin
setlength(sub_words,0);
while sub<>'' do
      begin
      extract3(sub,t,c);
      sub:=c;
      setlength(sub_words,length(sub_words)+1);
      sub_words[length(sub_words)-1]:=t;
      end;
end;

//-------------------------------------------------------------------

procedure get_n_sub(n_word:integer; const sub_word:Arr_string; var sub_n,sub_nn:string);  // n_word start from 1, as 0
begin
n_word:=n_word*2-1;
sub_n:='';
sub_nn:='';
dec(n_word);
if (n_word<0)or(length(sub_word)=0)or(n_word>=length(sub_word)) then Exit;
if sub_word[n_word][1] in ['?','*'] then inc(n_word);
if n_word>=length(sub_word) then Exit;
sub_n:=sub_word[n_word];
if n_word+1>=length(sub_word) then Exit;
sub_nn:=sub_word[n_word+1];
end;

//-------------------------------------------------------------------

procedure generate_word(str:string; var mask:arr_string);
var s:string;  // str=...00...00..... out mask=[00,...,00,.....]
begin
setlength(mask,0);
while (str<>'') and (str[1]='.') do str:=copy(str,2,length(str));
while str<>'' do
      begin
      s:='';
      while (str<>'') and ( ( (str[1]='0')and(length(mask) mod 2=0) )  or  ( (str[1]='.')and(length(mask) mod 2=1) ) ) do
            begin
            s:=s+str[1];
            str:=copy(str,2,length(str));
            end;
      setlength(mask,length(mask)+1);
      mask[length(mask)-1]:=s;
      end;
end;

//-------------------------------------------------------------------

procedure get_n_word2(n:integer; const mask:arr_string; var str_n,str_nn:string);
begin    // mask= [00,...,00,.....] or [000,...,00]  , n start from 1
if n*2-2<length(mask) then str_n:=mask[n*2-2]
                      else str_n:='';
if n*2-1<length(mask) then str_nn:=mask[n*2-1]
                      else str_nn:='';
end;

//-------------------------------------------------------------------

function  f_get_n_word2(n:integer; const mask:arr_string):string;
var str_nn:string;
begin
get_n_word2(n,mask,result,str_nn);
end;

//-------------------------------------------------------------------

function FindPart2(sub, Str: string): Integer;
var words,all_str,sub_word,mask: Arr_string;
    solution,multi_solution: Arr_integer;
    get_ask_count_,value,i,n_word:integer;
    sub_n,sub_nn,str_n,str_nn:string;
    all_0:boolean;
begin // the author of this function and sub functions is Salvatore Licciardi
if (sub='')or(Str='') then Exit(0);
sub:=fix_sub(sub);
get_all_word(sub,words);
get_ask_count_:=get_ask_count(sub);
if length(words)=0 then       // condition ??*  or ????
   if get_ask_count_>length(str) then Exit(0)
                                 else exit(1);
setlength(all_str,1);
all_str[0]:='';
while length(all_str[0])<length(str) do all_str[0]:='.'+all_str[0]; // first string generated

for i:=0 to length(words)-1 do
    begin
    pos2(words[i],str,solution);
    generate(all_str,length(words[i]),solution);
    end;

split_sub(sub,sub_word);
setlength(multi_solution,length(all_str));
for i:=0 to length(all_str)-1 do
    begin
    n_word:=0;
    multi_solution[i]:=pos('0',all_str[i]);
    generate_word(all_str[i],mask);
    repeat
     get_n_sub(n_word+1,sub_word,sub_n,sub_nn);
     if sub_n='' then break;
     get_n_word2(n_word+1,mask,str_n,str_nn);
     if ( length(sub_n)=length(str_n) )  and
          ( (sub_nn='') or (length(sub_nn)=length(str_nn)) or
            ( (length(sub_nn)<length(str_nn))and(f_get_n_word2(n_word+2,mask)=''{is it last word?}) ) or
          ( (length(sub_nn)<length(str_nn))and(pos('*',sub_nn)>0) )  )
             then   // there is a solution ? see after
             else
              begin
              multi_solution[i]:=0;
              break;
              end;
     inc(n_word);  //  check if next sub_word is valid
    until false;
    end;
value:=length(str);
all_0:=true;
for i:=0 to length(multi_solution)-1 do // search the least that isn't 0
    begin
    multi_solution[i]:=multi_solution[i]-get_ask_count_;
    if (multi_solution[i]>0)and(pos('*',sub_word[0])>0) then multi_solution[i]:=1; // check_asterisk into first word
    if (multi_solution[i]>0) and (multi_solution[i]<value) then
                                                           begin
                                                           value:=multi_solution[i];
                                                           all_0:=false;
                                                           end;
    end;
if all_0 then value:=0;
Exit(value);
end;

//-------------------------------------------------------------------

function IsWild2(InputStr: String;  Wilds: String;  IgnoreCase: Boolean ):Boolean;
begin
if IgnoreCase then exit(FindPart2(upcase(Wilds),upcase(InputStr))>0)
              else exit(FindPart2(Wilds,InputStr)>0);
end;

begin
writeln('------------------');
writeln(FindPart2('de?g','abcdefghdefgdefgg'));           // 4
writeln(FindPart2('de*','abcdefgh'));                     // 4
writeln(FindPart2('de???????op','abcdefghilmnopqrst'));   // 4
writeln(FindPart2('de??op','abcdefghilmnopqrst'));        // 0
writeln(FindPart2('de????????op','abcdefghilmnopqrst'));  // 0
writeln(FindPart2('de??**op','abcdefghilmnopqrst'));      // 4
writeln(FindPart2('de??**??op','abcdefghilmnopqrst'));    // 4
writeln(FindPart2('de??**op','abcdefghilmnopqrst'));      // 4
writeln(FindPart2('de??**o?q','abcdefghilmnopqrst'));     // 4
writeln(FindPart2('q','abcdefghilmnopqrst'));      // 15
writeln(FindPart2('','abcdefghilmnopqrst'));       // 0 come writeln(pos('','abcdefghilmnopqrst'));      // 0
writeln(FindPart2('*','abcdefghilmnopqrst'));      // 1
writeln(FindPart2('*?','abcdefghilmnopqrst'));     // 1
writeln(FindPart2('*?b','abcdefghilmnopqrst'));    // 1
writeln(FindPart2('?b','abcdefghilmnopqrst'));     // 1
writeln(FindPart2('b','abcdefghilmnopqrst'));      // 2
writeln(FindPart2('b********************************','abcdefghilmnopqrst')); // 2
writeln(FindPart2('b???????*?????????????????????????','abcdefghilmnopqrst'));// 0
writeln(FindPart2('??:??:??','12:00:30'));  // 1    OK
//writeln(FindPart('??:??:??','12:00:30'));   // 1    OK
writeln(FindPart2('??:??:??','     01:30:00'));      // 6
writeln(FindPart2('*??*c','abcdefghilmnopqrst'));    // 1
writeln(FindPart2('?*?:??:??','     01:30:00'));     // 1 or 6
writeln(FindPart2('??:*?:??','     01:30:00'));      // 6
writeln(FindPart2('*?*?:??:??','     01:30:00'));    // 1
writeln(FindPart2('??:??:??','a12:13:14'));          // 2
writeln(FindPart2('ci?cio','cixxciociccio'));        // 8
writeln(FindPart2('?ci?cio','cixxciociccio'));       // 7
// writeln(FindPart ('?ci?cio','cixxciociccio'));       // 7
writeln(FindPart2('ci','cixxciociccio'));            // 1
writeln(FindPart2('?x?????????','cixxciociccioj'));  // 2
writeln(FindPart2('ci*o?o','ci*o?p?o?o'));  // 1 ok
writeln(FindPart2('*','ci*o?p?o?o'));  // 1 ok dddddd???
end.

//----------------- DOCUMENTATION
 IsWild
 Check whether a string matches a wildcard
 search expression.

 Declaration
 Source position: strutils.pp line 158

 function IsWild(
   InputStr: String;
   Wilds: String;
   IgnoreCase: Boolean
 ):Boolean;



//-------------------------------- l'originale -- ORIGINAL VERISION
function FindPart(const HelpWilds, inputStr: string): Integer;
var
  i, J: Integer;
  Diff: Integer;
begin
  Result:=0;
  i:=Pos('?',HelpWilds);
  if (i=0) then
    Result:=Pos(HelpWilds, inputStr)
  else
    begin
    Diff:=Length(inputStr) - Length(HelpWilds);
    for i:=0 to Diff do
      begin
      for J:=1 to Length(HelpWilds) do
        if (inputStr[i + J] = HelpWilds[J]) or (HelpWilds[J] = '?') then
          begin
          if (J=Length(HelpWilds)) then
            begin
            Result:=i+1;
            Exit;
            end;
          end
        else
          Break;
      end;
    end;
end;


//----------------------------- DOCUMENTATION

27.3.37 FindPart
Synopsis: Search for a substring in a string, using wildcards.
Declaration: function FindPart(const HelpWilds: String;const InputStr: String)
: Integer

Visibility: default
Description: FindPart searches the string InputStr and returns the first
 string that matches the wildcards specification in HelpWilds . If no
 match is found, and empty string is returned. valid wildcards
are the "?" (question mark) and "*" (asterisk) characters.

Errors: None.



//-----------------------
function FindPart(const HelpWilds, inputStr: string): Integer;
var      // equivalente all'originale dddddd
  i,J,Diff: Integer;
begin
FindPart:=0;
i:=Pos('?',HelpWilds);
if (i=0) then
    FindPart:=Pos(HelpWilds, inputStr)
  else
    begin
    Diff:=Length(inputStr) - Length(HelpWilds);
    for i:=0 to Diff do
      for J:=1 to Length(HelpWilds) do
          if (inputStr[i + J] = HelpWilds[J]) or (HelpWilds[J] = '?') then
             if J=Length(HelpWilds) then Exit(i+1)
                                    else
             else Break;
    end;
end;




//-------------- TESTS
(*
get_n_sub(1{n_word},sub_word,sub_n,sub_nn);  // test OK

writeln(sub_n);
writeln(sub_nn);
get_n_sub(2{n_word},sub_word,sub_n,sub_nn);
writeln(sub_n);
writeln(sub_nn);
get_n_sub(3{n_word},sub_word,sub_n,sub_nn);
writeln(sub_n);
writeln(sub_nn);   //dddd *)


{writeln('....0..00...000....0000....00000.....');  // test OK
for i:=1 to 6 do   // test OK
    begin
    get_n_word(i,'....0..00...000....0000....00000.....',sub_n,sub_nn);  // test OK
    writeln(sub_n,'  ',sub_nn);
    end;  ///ddddd }


{var s:arr_integer; //dddddd sol_pos;
    i:integer;   }


(* writeln('------------------');
writeln(fix_sub('aaa?*?**p??*???p*'));

pos2('ab','ababab',s);
for i:=0 to length(s)-1 do writeln(s[i]); *)
