unit Find_SL;
{$mode objfpc}
interface

uses type_F_SL;

type Find=object
     private
      procedure extract3(sub:string; var t,c:string);
      function  fix_sub(const sub:string):string;
      function  get_invalid_char(const str:string):char;
      function  get_ask_count(const sub:string):integer;
      procedure pos2(sub,str:string; var solution: Arr_integer);
      procedure get_all_word(sub:string; var words:Arr_String);
      procedure generate(var all_str:arr_string; const length_words:integer; const solution:arr_integer);
      procedure split_sub(sub:string; var sub_words:Arr_string);
      procedure get_n_sub(n_word:integer; const sub_word:Arr_string; var sub_n,sub_nn:string);
      procedure generate_word(str:string; var mask:arr_string);
      procedure get_n_word2(n:integer; const mask:arr_string; var str_n,str_nn:string);
      function  f_get_n_word2(n:integer; const mask:arr_string):string;
      valid_i_solution:arr_integer;
      valid_s_solution:arr_string;
      asterisk_at_end:boolean;

     public
      function     FindPart2(sub, Str: string): Integer;
      function     get_found(): Integer;
      procedure    get_solution(pos:integer; var start:integer; var str:string);
     end;

implementation

//-------------------------------------------------------------------

procedure Find.extract3(sub:string; var t,c:string);  // T=head   C=tail
var jolly:boolean;
begin     // you must run it after FIX_SUB
t:='';            // aa??*bb --> aa/??*/bb
jolly:= (sub<>'')and(sub[1] in ['?','*']);
while (sub<>'') and ( ((sub[1] in ['?','*']) and jolly) or (not (sub[1] in ['?','*']) and not jolly) ) do
      begin
      t:=t+sub[1];
      sub:=copy(sub,2,length(sub));
      end;
c:=sub;
end;

//-------------------------------------------------------------------

function Find.fix_sub(const sub:string):string;
var i:integer;       // aaa?*?**p??*???p* --> aaa??*p?????*p
    was_asterisk:boolean;
begin   // if sub=='*' , fix_sub return '', but after program do exit(1) : OK
was_asterisk:=false;
result:='';
for i:=1 to length(sub) do
    case sub[i] of
         '*' : was_asterisk:=true;
         '?' : result:=result+sub[i];
         else
          begin
          if was_asterisk then
             begin
             result:=result+'*';
             was_asterisk:=false;
             end;
          result:=result+sub[i];
          end;
         end;  // case
asterisk_at_end:=was_asterisk;
while (result<>'')and(result[length(result)]='*') do result:=copy(result,1,length(result)-1);
end;

//-------------------------------------------------------------------

function Find.get_invalid_char(const str:string):char;
begin
if (length(str)>1) and (str[1]<#255) then get_invalid_char:=char(ord(str[1])+1)
                                     else get_invalid_char:=#0;
end;

//-------------------------------------------------------------------

function Find.get_ask_count(const sub:string):integer;
begin     // you must run it after FIX_SUB
result:=0;
while (length(sub)>result)and(sub[result+1]='?') do inc(result);
end;

//-------------------------------------------------------------------

procedure Find.pos2(sub,str:string; var solution: Arr_integer);
var bad:char;
    position:integer;
begin
setlength(solution,0);
bad:=get_invalid_char(sub);
repeat
 position:=pos(sub,str);
 if position=0 then break;
 setlength(solution,length(solution)+1);
 solution[length(solution)-1]:=position;
 str[position]:=bad;
until false;
end;

//-------------------------------------------------------------------

procedure Find.get_all_word(sub:string; var words:Arr_String);
var t,c:string;     // T=head   C=tail
begin
setlength(words,0);
while sub<>'' do
      begin
      extract3(sub,t,c);
      sub:=c;
      if (t<>'') and not (t[1] in ['?','*']) then  // is a word: insert it
         begin
         setlength(words,length(words)+1);
         words[length(words)-1]:=t;
         end;
      end;
end;

//-------------------------------------------------------------------

procedure Find.generate(var all_str:arr_string; const length_words:integer; const solution:arr_integer);
var new_all_str:arr_string;
    index_,fix_pos,i,j,k,last_used_position:integer;
begin
setlength(new_all_str,length(all_str)*length(solution));
index_:=0;
for i:=0 to length(all_str)-1 do  // multiplication of all_str
    begin
    fix_pos:=0;
    for k:=0 to length(solution)-1 do
        begin
        new_all_str[index_]:=all_str[i];
        last_used_position:=0;
        for j:=length(new_all_str[index_]) downto 1 do
            if new_all_str[index_][j]='0' then
               begin  // position o first '0' from Right to Left
               last_used_position:=j;
               break;
               end;
        if (last_used_position<solution[fix_pos])or(last_used_position=0) then // skip position before have sense
           for j:=0 to length_words-1 do new_all_str[index_][solution[fix_pos]+j]:='0';
        inc(index_);
        inc(fix_pos);
        end;
    end;
setlength(all_str,0);
all_str:=new_all_str;
end;

//-------------------------------------------------------------------

procedure Find.split_sub(sub:string; var sub_words:Arr_string);
var t,c:string;      // aa??*bb --> [aa,??*,bb]
begin
setlength(sub_words,0);
while sub<>'' do
      begin
      extract3(sub,t,c);
      sub:=c;
      setlength(sub_words,length(sub_words)+1);
      sub_words[length(sub_words)-1]:=t;
      end;
end;

//-------------------------------------------------------------------

procedure Find.get_n_sub(n_word:integer; const sub_word:Arr_string; var sub_n,sub_nn:string);  // n_word start from 1, as 0
begin
n_word:=n_word*2-1;
sub_n:='';
sub_nn:='';
dec(n_word);
if (n_word<0)or(length(sub_word)=0)or(n_word>=length(sub_word)) then Exit;
if sub_word[n_word][1] in ['?','*'] then inc(n_word);
if n_word>=length(sub_word) then Exit;
sub_n:=sub_word[n_word];
if n_word+1>=length(sub_word) then Exit;
sub_nn:=sub_word[n_word+1];
end;

//-------------------------------------------------------------------

procedure Find.generate_word(str:string; var mask:arr_string);
var s:string;  // str=...00...00..... out mask=[00,...,00,.....]
begin
setlength(mask,0);
while (str<>'') and (str[1]='.') do str:=copy(str,2,length(str));
while str<>'' do
      begin
      s:='';
      while (str<>'') and ( ( (str[1]='0')and(length(mask) mod 2=0) )  or  ( (str[1]='.')and(length(mask) mod 2=1) ) ) do
            begin
            s:=s+str[1];
            str:=copy(str,2,length(str));
            end;
      setlength(mask,length(mask)+1);
      mask[length(mask)-1]:=s;
      end;
end;

//-------------------------------------------------------------------

procedure Find.get_n_word2(n:integer; const mask:arr_string; var str_n,str_nn:string);
begin    // mask= [00,...,00,.....] or [000,...,00]  , n start from 1
if n*2-2<length(mask) then str_n:=mask[n*2-2]
                      else str_n:='';
if n*2-1<length(mask) then str_nn:=mask[n*2-1]
                      else str_nn:='';
end;

//-------------------------------------------------------------------

function  Find.f_get_n_word2(n:integer; const mask:arr_string):string;
var str_nn:string;
begin
get_n_word2(n,mask,result,str_nn);
end;

//-------------------------------------------------------------------

function Find.FindPart2(sub, Str: string): Integer;
var words,all_str,sub_word,mask: Arr_string;
    solution,multi_solution,length_str: Arr_integer;
    get_ask_count_,i,n_word,original_multi_solution:integer;
    sub_n,sub_nn,str_n,str_nn:string;
begin // the author of this function and sub functions is Salvatore Licciardi
if (sub='')or(Str='') then Exit(0);
sub:=fix_sub(sub);
get_all_word(sub,words);
get_ask_count_:=get_ask_count(sub);
if length(words)=0 then       // condition ??*  or ????
   if get_ask_count_>length(str) then Exit(0)
                                 else
                                  begin
                                  setlength(valid_i_solution,1);
                                  valid_i_solution[0]:=1;
                                  setlength(valid_s_solution,1);
                                  valid_s_solution[0]:=str;
                                  exit(1);
                                  end;
setlength(all_str,1);
all_str[0]:='';
while length(all_str[0])<length(str) do all_str[0]:='.'+all_str[0]; // first string generated

for i:=0 to length(words)-1 do
    begin
    pos2(words[i],str,solution);
    generate(all_str,length(words[i]),solution);
    end;

split_sub(sub,sub_word);
setlength(multi_solution,length(all_str));
setlength(length_str,length(all_str));
for i:=0 to length(all_str)-1 do
    begin
    n_word:=0;
    multi_solution[i]:=pos('0',all_str[i]);
    length_str[i]:=0;
    generate_word(all_str[i],mask);
    repeat
     get_n_sub(n_word+1,sub_word,sub_n,sub_nn);
     if sub_n='' then break;
     get_n_word2(n_word+1,mask,str_n,str_nn);
     if ( length(sub_n)=length(str_n) )  and
          ( (sub_nn='') or (length(sub_nn)=length(str_nn)) or
            ( (length(sub_nn)<length(str_nn))and(f_get_n_word2(n_word+2,mask)=''{is it last word?}) ) or
          ( (length(sub_nn)<length(str_nn))and(pos('*',sub_nn)>0) )  )
             then   // there is a solution ? see after
              begin
              length_str[i]:=length_str[i]+length(str_n);
              if length(sub_nn)=length(str_nn) then length_str[i]:=length_str[i]+length(str_nn)
                 else
              if (length(sub_nn)<length(str_nn))and(f_get_n_word2(n_word+2,mask)=''{is it last word?}) then length_str[i]:=length_str[i]+length(sub_nn)
                 else
              if (length(sub_nn)<length(str_nn))and(pos('*',sub_nn)>0) then length_str[i]:=length_str[i]+length(str_nn);
              end
             else
              begin
              multi_solution[i]:=0;
              length_str[i]:=0;
              break;
              end;
     inc(n_word);  //  check if next sub_word is valid
    until false;
    end;
setlength(valid_i_solution,0);
setlength(valid_s_solution,0);

for i:=0 to length(multi_solution)-1 do // search the least that isn't 0
    begin
    multi_solution[i]:=multi_solution[i]-get_ask_count_;
    if (multi_solution[i]>0)and(pos('*',sub_word[0])>0) then
                                                        begin
                                                        original_multi_solution:=multi_solution[i];
                                                        multi_solution[i]:=1; // check_asterisk into first word
                                                        end;
    if multi_solution[i]>0 then
       begin
       setlength(valid_i_solution,length(valid_i_solution)+1);
       valid_i_solution[length(valid_i_solution)-1]:=multi_solution[i];
       setlength(valid_s_solution,length(valid_s_solution)+1);
       if asterisk_at_end then valid_s_solution[length(valid_s_solution)-1]:=copy(str,multi_solution[i],length(str))
                          else valid_s_solution[length(valid_s_solution)-1]:=copy(str,multi_solution[i],length_str[i]+get_ask_count_);
       if (length(sub_word)>1) and (pos('*',sub_word[0])>0) then valid_s_solution[length(valid_s_solution)-1]:=copy(str,1,original_multi_solution-1+length(valid_s_solution[length(valid_s_solution)-1]));
       end;
    end;
Exit(length(valid_i_solution));
end;

//-------------------------------------------------------------------

procedure    Find.get_solution(pos:integer; var start:integer; var str:string);
begin
start:=0;
str:='';
if (pos<1)or(pos>length(valid_s_solution)) then Exit;
start:=valid_i_solution[pos-1];
str:=valid_s_solution[pos-1];
end;

//-------------------------------------------------------------------

function     Find.get_found():Integer;
begin
exit(length(valid_i_solution));
end;

//-------------------------------------------------------------------

end.


{
Wildcards Pattern Matching Algorithm (FindPart for Free Pascal Compiler 2.0.0)

The author of this algorithm, function and sub functions is
Salvatore Licciardi (turylicciardi@tiscali.it , www.webalice.it/turylicciardi)

step 1)  Move from 'sub', all '*' on right of '?' (only a copy of '*' you need)
         end remove '*' at  the end of 'sub';

         This is function Find.fix_sub(const sub:string):string;
         example: aaa?*?**p??*???p* --> aaa??*p?????*p

step 2)  Generate all possible solutions (also not valids);
step 3)  Check if a solution is valid;

step 4)  Return solution: position where start, and string.
         FindPart can return 0, 1 or more solutions. If you need only the 1st,
         it has the least value of all other solutions. If no solution, it is
         0;

Before to know how work step 2 and 3, you need to know other function how works.

procedure Find.extract3(sub:string; var t,c:string);  // T=head   C=tail
  You must run it after FIX_SUB.
  If you call more time it, you can split 'sub' in word and wildcards;
  Example    'aa??*bb' --> T='aa'  and C='??*bb' after
  Example    '??*bb'   --> T='??*' and C='bb' after
  Example    'bb'      --> T='bb'  and C=''

function Find.get_invalid_char(const str:string):char;
  Get a not valid char: used with 'pos2' to have a sense.

function Find.get_ask_count(const sub:string):integer;
  You must run it after FIX_SUB.
  Return the number of '?' that there are at the start of 'sub';

procedure Find.pos2(sub,str:string; var solution: Arr_integer);
  It return into 'solution' all position where you can found 'sub' into 'str'.
  Example: 'xy' into 'xyaaxyxx'  return position [1,5]
  Example: 'xx' into  'xxx'  return position [1,2]

procedure Find.get_all_word(sub:string; var words:Arr_String);
  Insert into 'words' all words (no wildcard) that there are into 'sub'.
  Example: 'aa??*bb*cc' return ['aa','bb','cc']

procedure Find.split_sub(sub:string; var sub_words:Arr_string);
  Insert into 'sub_words' all words (also wildcard) that there are into 'sub'.
  Example: 'aa??*bb*cc' return ['aa','??*','bb','*','cc']

procedure Find.get_n_sub(n_word:integer; const sub_word:Arr_string; var sub_n,sub_nn:string);
  n_word start from 1, as 0
  Return the sub_word (without wildcards) into sub_N, and next (with
  wildcards) into sub_NN;

  Example: sub_word=['?','a','??','b','???','c','???'] and n_word=2,
  then return sub_n='b' and sub_nn='???';

procedure generate_word(str:string; var mask:arr_string);
  Return a 'mask' of 'str' as the example:
  str='...00...00.....' out mask=['00','...','00','.....']

procedure get_n_word2(n:integer; const mask:arr_string; var str_n,str_nn:string);
  Return the 'n' pair words of the 'mask' (n start from 1)
  Example: mask= ['00','..','000','.....','0','...']   and  n=2
           return str_n='000'  and  str_nn='.....'

function  f_get_n_word2(n:integer; const mask:arr_string):string;
  Return the first element of 'n' pair words of the 'mask' (n start from 1)
  Example: mask= ['00','..','000','.....','0','...']   and  n=2
           return '000'  (skip the '.....')

procedure generate(var all_str:arr_string; const length_words:integer; const solution:arr_integer);
  From the strings in 'all_str', it do other strings, where POS2 can found solution.
  For each string there are new 'length of solution' strings: insert(s) the
  '0' where POS2 had solution.

PUBLIC :

function     get_found(): Integer;
  Retun the number of solutions.

procedure    get_solution(pos:integer; var start:integer; var str:string);
  Return the posTH solution: char where start and the string.

function     FindPart2(sub, Str: string): Integer;
  Run the Algorithm and return the number of solutions.

  Work so:

step 2)  Generate all possible solutions (also not valids):

For each words into substring (without wildcard), search
    where pos2 retrn all solution,
    and generate all mask as string solution

step 3)  Check if a solution is valid:

For all solution mask generated
    try to insert the sub string into them.
    If can insert it, position is the first match, otherwise 0;
For all solution (that aren't 0) subtract the number of '?' that 'sub' start
    and check that is there is '*', position start at 1.

Retun number of solution founded.

}
